Index: src/backend/utils/adt/pgstatfuncs.c
===================================================================
RCS file: /projects/cvsroot/pgsql-server/src/backend/utils/adt/pgstatfuncs.c,v
retrieving revision 1.9
diff -u -d -r1.9 pgstatfuncs.c
--- src/backend/utils/adt/pgstatfuncs.c	2002/12/04 05:18:34	1.9
+++ src/backend/utils/adt/pgstatfuncs.c	2003/03/07 04:09:01
@@ -284,12 +284,12 @@
 	int			len;
 	text	   *result;
 
-	if (!superuser())
-		PG_RETURN_NULL();
-
 	beid = PG_GETARG_INT32(0);
 
 	if ((beentry = pgstat_fetch_stat_beentry(beid)) == NULL)
+		PG_RETURN_NULL();
+
+	if (!superuser() && beentry->userid != GetUserId())
 		PG_RETURN_NULL();
 
 	len = strlen(beentry->activity);
